--- lrb_prototype_primitives.inl	2010-06-15 17:01:51.147217886 +0200
+++ lrbni_prototypes.h	2010-06-15 17:01:22.767217213 +0200
@@ -9316,9 +9340,9 @@
     _M512I result;
     __mmask returnMask = 0;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p3 = (unsigned int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p3 = (_LPP_UInt *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -9342,9 +9366,9 @@
     _M512I result;
     __mmask returnMask = 0;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p3 = (unsigned int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p3 = (_LPP_UInt *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p1[i] - p3[i];
@@ -9361,9 +9385,9 @@
     _M512I result;
     __mmask returnMask = 0;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p3 = (unsigned int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p3 = (_LPP_UInt *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -9387,8 +9411,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *p1 = (int *) &v1;
-    int *p2 = (int *) &v2;
+    _LPP_Int *p1 = (_LPP_Int *) &v1;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 16; i++) {
         if ((p1[i] & p2[i]) != 0) result |= (1 << i);
@@ -9419,9 +9443,9 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = (p2[i] ^ p3[i]);
@@ -9444,10 +9468,10 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -9487,10 +9511,10 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int64_t *r = (int64_t *) &result;
-    int64_t *p1 = (int64_t *) &v1_old;
-    int64_t *p2 = (int64_t *) &v2;
-    int64_t *p3 = (int64_t *) &v3;
+    _LPP_Int64 *r = (_LPP_Int64 *) &result;
+    _LPP_Int64 *p1 = (_LPP_Int64 *) &v1_old;
+    _LPP_Int64 *p2 = (_LPP_Int64 *) &v2;
+    _LPP_Int64 *p3 = (_LPP_Int64 *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -9565,7 +9589,7 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
+    _LPP_Int *r = (_LPP_Int *) &result;
 
     for (int i=0; i < 16; i++) {
         *r++ = 0;
@@ -9593,7 +9617,7 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
+    _LPP_Double *r = (_LPP_Double *) &result;
 
     for (int i=0; i < 8; i++) {
         r[i] = a[i];
@@ -9615,7 +9639,7 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
+    _LPP_Float *r = (_LPP_Float *) &result;
 
     for (int i=0; i < 16; i++) {
         r[i] = a[i];
@@ -9637,7 +9661,7 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
+    _LPP_Int *r = (_LPP_Int *) &result;
 
     for (int i=0; i < 16; i++) {
         r[i] = a[i];
@@ -9659,7 +9683,7 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
+    _LPP_Double *r = (_LPP_Double *) &result;
 
     for (int i=0; i < 8; i++) {
         r[i] = a;
@@ -9681,7 +9705,7 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int64_t *r = (int64_t *) &result;
+    _LPP_Int64 *r = (_LPP_Int64 *) &result;
 
     for (int i=0; i < 8; i++) {
         r[i] = a;
@@ -9703,7 +9727,7 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
+    _LPP_Float *r = (_LPP_Float *) &result;
 
     for (int i=0; i < 16; i++) {
         r[i] = a;
@@ -9725,7 +9749,7 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
+    _LPP_Int *r = (_LPP_Int *) &result;
 
     for (int i=0; i < 16; i++) {
         r[i] = a;
@@ -9747,7 +9771,7 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
+    _LPP_Double *r = (_LPP_Double *) &result;
 
     for (int i=0; i < 2; i++) {
         r[i*4+0] = a;
@@ -9773,7 +9797,7 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int64_t *r = (int64_t *) &result;
+    _LPP_Int64 *r = (_LPP_Int64 *) &result;
 
     for (int i=0; i < 2; i++) {
         r[i*4+0] = a;
@@ -9799,7 +9823,7 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
+    _LPP_Float *r = (_LPP_Float *) &result;
 
     for (int i=0; i < 4; i++) {
         r[i*4 + 0] = a;
@@ -9824,7 +9848,7 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
+    _LPP_Int *r = (_LPP_Int *) &result;
 
     for (int i=0; i < 4; i++) {
         r[i*4 + 0] = a;
@@ -9850,7 +9874,7 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
+    _LPP_Float *r = (_LPP_Float *) &result;
 
     r[0] = e0;  r[1] = e1;  r[2] = e2;  r[3] = e3;
     r[4] = e4;  r[5] = e5;  r[6] = e6;  r[7] = e7;
@@ -9876,7 +9900,7 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
+    _LPP_Int *r = (_LPP_Int *) &result;
 
     r[0] = e0;  r[1] = e1;  r[2] = e2;  r[3] = e3;
     r[4] = e4;  r[5] = e5;  r[6] = e6;  r[7] = e7;
@@ -9901,7 +9925,7 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
+    _LPP_Double *r = (_LPP_Double *) &result;
 
     r[0] = e0;  r[1] = e1;
     r[2] = e2;  r[3] = e3;
@@ -9926,7 +9950,7 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int64_t *r = (int64_t *) &result;
+    _LPP_Int64 *r = (_LPP_Int64 *) &result;
 
     r[0] = e0;  r[1] = e1;
     r[2] = e2;  r[3] = e3;
@@ -9952,8 +9976,8 @@
 inline _M512D _mm512_acos_pd(_M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         r[i] = acos(p1[i]);
@@ -9965,9 +9989,9 @@
 inline _M512D _mm512_mask_acos_pd(_M512D v0_old, __mmask k1, _M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -9984,8 +10008,8 @@
 inline _M512 _mm512_acos_ps(_M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         r[i] = acosf(p1[i]);
@@ -9997,9 +10021,9 @@
 inline _M512 _mm512_mask_acos_ps(_M512 v0_old, __mmask k1, _M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -10016,8 +10040,8 @@
 inline _M512D _mm512_asin_pd(_M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         r[i] = asin(p1[i]);
@@ -10029,9 +10053,9 @@
 inline _M512D _mm512_mask_asin_pd(_M512D v0_old, __mmask k1, _M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -10048,8 +10072,8 @@
 inline _M512 _mm512_asin_ps(_M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         r[i] = asinf(p1[i]);
@@ -10061,9 +10085,9 @@
 inline _M512 _mm512_mask_asin_ps(_M512 v0_old, __mmask k1, _M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -10080,9 +10104,9 @@
 inline _M512D _mm512_atan2_pd(_M512D v1, _M512D v2)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         r[i] = atan2(p1[i], p2[i]);
@@ -10094,10 +10118,10 @@
 inline _M512D _mm512_mask_atan2_pd(_M512D v0_old, __mmask k1, _M512D v1, _M512D v2)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -10114,9 +10138,9 @@
 inline _M512 _mm512_atan2_ps(_M512 v1, _M512 v2)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         r[i] = atan2f(p1[i], p2[i]);
@@ -10128,10 +10152,10 @@
 inline _M512 _mm512_mask_atan2_ps(_M512 v0_old, __mmask k1, _M512 v1, _M512 v2)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -10148,8 +10172,8 @@
 inline _M512D _mm512_atan_pd(_M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         r[i] = atan(p1[i]);
@@ -10161,9 +10185,9 @@
 inline _M512D _mm512_mask_atan_pd(_M512D v0_old, __mmask k1, _M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -10180,8 +10204,8 @@
 inline _M512 _mm512_atan_ps(_M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         r[i] = atanf(p1[i]);
@@ -10193,9 +10217,9 @@
 inline _M512 _mm512_mask_atan_ps(_M512 v0_old, __mmask k1, _M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -10212,8 +10236,8 @@
 inline _M512D _mm512_ceil_pd(_M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         r[i] = ceil(p1[i]);
@@ -10225,9 +10249,9 @@
 inline _M512D _mm512_mask_ceil_pd(_M512D v0_old, __mmask k1, _M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -10244,8 +10268,8 @@
 inline _M512 _mm512_ceil_ps(_M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         r[i] = ceilf(p1[i]);
@@ -10257,9 +10281,9 @@
 inline _M512 _mm512_mask_ceil_ps(_M512 v0_old, __mmask k1, _M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -10276,8 +10300,8 @@
 inline _M512D _mm512_cos_pd(_M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         r[i] = cos(p1[i]);
@@ -10289,9 +10313,9 @@
 inline _M512D _mm512_mask_cos_pd(_M512D v0_old, __mmask k1, _M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -10308,8 +10332,8 @@
 inline _M512 _mm512_cos_ps(_M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         r[i] = cosf(p1[i]);
@@ -10321,9 +10345,9 @@
 inline _M512 _mm512_mask_cos_ps(_M512 v0_old, __mmask k1, _M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -10340,8 +10364,8 @@
 inline _M512D _mm512_cosh_pd(_M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         r[i] = cosh(p1[i]);
@@ -10353,9 +10377,9 @@
 inline _M512D _mm512_mask_cosh_pd(_M512D v0_old, __mmask k1, _M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -10372,8 +10396,8 @@
 inline _M512 _mm512_cosh_ps(_M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         r[i] = coshf(p1[i]);
@@ -10385,9 +10409,9 @@
 inline _M512 _mm512_mask_cosh_ps(_M512 v0_old, __mmask k1, _M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -10404,8 +10428,8 @@
 inline _M512D _mm512_exp2_pd(_M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         r[i] = pow(2.0, p1[i]);
@@ -10417,9 +10441,9 @@
 inline _M512D _mm512_mask_exp2_pd(_M512D v0_old, __mmask k1, _M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -10436,8 +10460,8 @@
 inline _M512 _mm512_exp2_ps(_M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         r[i] = powf(2.0f, p1[i]);
@@ -10449,9 +10473,9 @@
 inline _M512 _mm512_mask_exp2_ps(_M512 v0_old, __mmask k1, _M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -10468,8 +10492,8 @@
 inline _M512D _mm512_exp_pd(_M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         r[i] = exp(p1[i]);
@@ -10481,9 +10505,9 @@
 inline _M512D _mm512_mask_exp_pd(_M512D v0_old, __mmask k1, _M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -10500,8 +10524,8 @@
 inline _M512 _mm512_exp_ps(_M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         r[i] = expf(p1[i]);
@@ -10513,9 +10537,9 @@
 inline _M512 _mm512_mask_exp_ps(_M512 v0_old, __mmask k1, _M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -10532,8 +10556,8 @@
 inline _M512D _mm512_floor_pd(_M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         r[i] = floor(p1[i]);
@@ -10545,9 +10569,9 @@
 inline _M512D _mm512_mask_floor_pd(_M512D v0_old, __mmask k1, _M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -10564,8 +10588,8 @@
 inline _M512 _mm512_floor_ps(_M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         r[i] = floorf(p1[i]);
@@ -10577,9 +10601,9 @@
 inline _M512 _mm512_mask_floor_ps(_M512 v0_old, __mmask k1, _M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -10596,9 +10620,9 @@
 inline _M512D _mm512_hypot_pd(_M512D v1, _M512D v2)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         r[i] = _hypot(p1[i], p2[i]);
@@ -10610,10 +10634,10 @@
 inline _M512D _mm512_mask_hypot_pd(_M512D v0_old, __mmask k1, _M512D v1, _M512D v2)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -10630,9 +10654,9 @@
 inline _M512 _mm512_hypot_ps(_M512 v1, _M512 v2)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         r[i] = _hypotf(p1[i], p2[i]);
@@ -10644,10 +10668,10 @@
 inline _M512 _mm512_mask_hypot_ps(_M512 v0_old, __mmask k1, _M512 v1, _M512 v2)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -10664,9 +10688,9 @@
 inline _M512I _mm512_div_pi(_M512I v1, _M512I v2)
 {
     _M512I result;
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1;
-    int *p2 = (int *) &v2;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (p2[i] != 0) r[i] = p1[i] / p2[i];
@@ -10679,10 +10703,10 @@
 inline _M512I _mm512_mask_div_pi(_M512I v0_old, __mmask k1, _M512I v1, _M512I v2)
 {
     _M512I result;
-    int *r = (int *) &result;
-    int *p0 = (int *) &v0_old;
-    int *p1 = (int *) &v1;
-    int *p2 = (int *) &v2;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p0 = (_LPP_Int *) &v0_old;
+    _LPP_Int *p1 = (_LPP_Int *) &v1;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -10700,9 +10724,9 @@
 inline _M512 _mm512_div_ps(_M512 v1, _M512 v2)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         r[i] = p1[i] / p2[i];
@@ -10714,10 +10738,10 @@
 inline _M512 _mm512_mask_div_ps(_M512 v0_old, __mmask k1, _M512 v1, _M512 v2)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -10734,9 +10758,9 @@
 inline _M512D _mm512_div_pd(_M512D v1, _M512D v2)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         r[i] = p1[i] / p2[i];
@@ -10748,10 +10772,10 @@
 inline _M512D _mm512_mask_div_pd(_M512D v0_old, __mmask k1, _M512D v1, _M512D v2)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -10768,9 +10792,9 @@
 inline _M512I _mm512_div_pu(_M512I v1, _M512I v2)
 {
     _M512I result;
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (p2[i] != 0) r[i] = p1[i] / p2[i];
@@ -10783,10 +10807,10 @@
 inline _M512I _mm512_mask_div_pu(_M512I v0_old, __mmask k1, _M512I v1, _M512I v2)
 {
     _M512I result;
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p0 = (unsigned int *) &v0_old;
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p0 = (_LPP_UInt *) &v0_old;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -10804,8 +10828,8 @@
 inline _M512D _mm512_rsqrt_pd(_M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         r[i] = 1.0 / sqrt(p1[i]);
@@ -10817,9 +10841,9 @@
 inline _M512D _mm512_mask_rsqrt_pd(_M512D v0_old, __mmask k1, _M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -10836,8 +10860,8 @@
 inline _M512 _mm512_rsqrt_ps(_M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         r[i] = 1.0f / sqrtf(p1[i]);
@@ -10849,9 +10873,9 @@
 inline _M512 _mm512_mask_rsqrt_ps(_M512 v0_old, __mmask k1, _M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -10868,8 +10892,8 @@
 inline _M512D _mm512_recip_pd(_M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         r[i] = 1.0 / p1[i];
@@ -10881,9 +10905,9 @@
 inline _M512D _mm512_mask_recip_pd(_M512D v0_old, __mmask k1, _M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p0 = (double *) &v0_old;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p0 = (_LPP_Double *) &v0_old;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -10900,8 +10924,8 @@
 inline _M512 _mm512_recip_ps(_M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         r[i] = 1.0f / p1[i];
@@ -10913,9 +10937,9 @@
 inline _M512 _mm512_mask_recip_ps(_M512 v0_old, __mmask k1, _M512 v1)
 {
     _M512 result;
-    float *r = (float *) &result;
-    float *p0 = (float *) &v0_old;
-    float *p1 = (float *) &v1;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p0 = (_LPP_Float *) &v0_old;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -10932,9 +10956,9 @@
 inline _M512I _mm512_rem_pi(_M512I v1, _M512I v2)
 {
     _M512I result;
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1;
-    int *p2 = (int *) &v2;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (p2[i] != 0) r[i] = p1[i] % p2[i];
@@ -10947,10 +10971,10 @@
 inline _M512I _mm512_mask_rem_pi(_M512I v0_old, __mmask k1, _M512I v1, _M512I v2)
 {
     _M512I result;
-    int *r = (int *) &result;
-    int *p0 = (int *) &v0_old;
-    int *p1 = (int *) &v1;
-    int *p2 = (int *) &v2;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p0 = (_LPP_Int *) &v0_old;
+    _LPP_Int *p1 = (_LPP_Int *) &v1;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -10968,9 +10992,9 @@
 inline _M512I _mm512_rem_pu(_M512I v1, _M512I v2)
 {
     _M512I result;
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (p2[i] != 0) r[i] = p1[i] % p2[i];
@@ -10983,10 +11007,10 @@
 inline _M512I _mm512_mask_rem_pu(_M512I v0_old, __mmask k1, _M512I v1, _M512I v2)
 {
     _M512I result;
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p0 = (unsigned int *) &v0_old;
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p0 = (_LPP_UInt *) &v0_old;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -11004,8 +11028,8 @@
 inline _M512D _mm512_log10_pd(_M512D v1)
 {
     _M512D result;
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
 
     for (int i=0; i < 8; i++) {
         r[i] = log10(p1[i]);
